/* rygel-media-export-plugin.c generated by valac, the Vala compiler
 * generated from rygel-media-export-plugin.vala, do not modify */

/*
 * Copyright (C) 2008-2009 Jens Georg <mail@jensge.org>.
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <rygel.h>
#include <glib/gi18n-lib.h>


#define RYGEL_MEDIA_EXPORT_TYPE_PLUGIN (rygel_media_export_plugin_get_type ())
#define RYGEL_MEDIA_EXPORT_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_PLUGIN, RygelMediaExportPlugin))
#define RYGEL_MEDIA_EXPORT_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_PLUGIN, RygelMediaExportPluginClass))
#define RYGEL_MEDIA_EXPORT_IS_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_PLUGIN))
#define RYGEL_MEDIA_EXPORT_IS_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_PLUGIN))
#define RYGEL_MEDIA_EXPORT_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_PLUGIN, RygelMediaExportPluginClass))

typedef struct _RygelMediaExportPlugin RygelMediaExportPlugin;
typedef struct _RygelMediaExportPluginClass RygelMediaExportPluginClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _RygelMediaExportPluginPrivate RygelMediaExportPluginPrivate;

struct _RygelMediaExportPlugin {
	RygelMediaServerPlugin parent_instance;
	RygelMediaExportPluginPrivate * priv;
};

struct _RygelMediaExportPluginClass {
	RygelMediaServerPluginClass parent_class;
};


static gpointer rygel_media_export_plugin_parent_class = NULL;

RygelMediaExportPlugin* rygel_media_export_plugin_new (void);
RygelMediaExportPlugin* rygel_media_export_plugin_construct (GType object_type);
GType rygel_media_export_plugin_get_type (void) G_GNUC_CONST;
void module_init (RygelPluginLoader* loader);
enum  {
	RYGEL_MEDIA_EXPORT_PLUGIN_DUMMY_PROPERTY
};
RygelMediaContainer* rygel_media_export_root_container_get_instance (void);
static RygelMediaContainer* rygel_media_export_plugin_real_get_root_container (RygelMediaServerPlugin* base, RygelContentDirectory* content_dir);



#line 30 "rygel-media-export-plugin.vala"
void module_init (RygelPluginLoader* loader) {
#line 69 "rygel-media-export-plugin.c"
	RygelMediaExportPlugin* plugin;
#line 30 "rygel-media-export-plugin.vala"
	g_return_if_fail (loader != NULL);
#line 31 "rygel-media-export-plugin.vala"
	plugin = rygel_media_export_plugin_new ();
#line 33 "rygel-media-export-plugin.vala"
	rygel_plugin_loader_add_plugin (loader, (RygelPlugin*) plugin);
#line 77 "rygel-media-export-plugin.c"
	_g_object_unref0 (plugin);
}


#line 37 "rygel-media-export-plugin.vala"
RygelMediaExportPlugin* rygel_media_export_plugin_construct (GType object_type) {
#line 84 "rygel-media-export-plugin.c"
	RygelMediaExportPlugin * self;
#line 38 "rygel-media-export-plugin.vala"
	self = (RygelMediaExportPlugin*) rygel_media_server_plugin_construct (object_type, "MediaExport", _ ("@REALNAME@'s media"), NULL);
#line 88 "rygel-media-export-plugin.c"
	return self;
}


#line 37 "rygel-media-export-plugin.vala"
RygelMediaExportPlugin* rygel_media_export_plugin_new (void) {
#line 37 "rygel-media-export-plugin.vala"
	return rygel_media_export_plugin_construct (RYGEL_MEDIA_EXPORT_TYPE_PLUGIN);
#line 97 "rygel-media-export-plugin.c"
}


#line 41 "rygel-media-export-plugin.vala"
static RygelMediaContainer* rygel_media_export_plugin_real_get_root_container (RygelMediaServerPlugin* base, RygelContentDirectory* content_dir) {
#line 103 "rygel-media-export-plugin.c"
	RygelMediaExportPlugin * self;
	RygelMediaContainer* result = NULL;
	self = (RygelMediaExportPlugin*) base;
#line 41 "rygel-media-export-plugin.vala"
	g_return_val_if_fail (content_dir != NULL, NULL);
#line 109 "rygel-media-export-plugin.c"
	result = rygel_media_export_root_container_get_instance ();
#line 43 "rygel-media-export-plugin.vala"
	return result;
#line 113 "rygel-media-export-plugin.c"
}


static void rygel_media_export_plugin_class_init (RygelMediaExportPluginClass * klass) {
	rygel_media_export_plugin_parent_class = g_type_class_peek_parent (klass);
	RYGEL_MEDIA_SERVER_PLUGIN_CLASS (klass)->get_root_container = rygel_media_export_plugin_real_get_root_container;
}


static void rygel_media_export_plugin_instance_init (RygelMediaExportPlugin * self) {
}


GType rygel_media_export_plugin_get_type (void) {
	static volatile gsize rygel_media_export_plugin_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_media_export_plugin_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelMediaExportPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_media_export_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMediaExportPlugin), 0, (GInstanceInitFunc) rygel_media_export_plugin_instance_init, NULL };
		GType rygel_media_export_plugin_type_id;
		rygel_media_export_plugin_type_id = g_type_register_static (RYGEL_TYPE_MEDIA_SERVER_PLUGIN, "RygelMediaExportPlugin", &g_define_type_info, 0);
		g_once_init_leave (&rygel_media_export_plugin_type_id__volatile, rygel_media_export_plugin_type_id);
	}
	return rygel_media_export_plugin_type_id__volatile;
}




